<?
if (!defined('_CONFBACKUP_CLASS')) {
	define('_CONFBACKUP_CLASS', true);

	require_once('/usr/local/www/berogui/misc/ini_to_db_functions.php');

	Class confBackup {

		private $_cardSerial;
		private $_ba;
		private $_confPath = '/usr/conf';
		private $_extractPath = '/tmp/restore';
		private $_confFiles = array(	array('name' => 'isgw.conf',		'initodb' => 'isgwconf_initoDB'),
						array('name' => 'isgw.sip',		'initodb' => 'isgwsip_initoDB'),
						array('name' => 'isgw.isdn',		'initodb' => 'isgwisdn_initoDB'),
						array('name' => 'isgw.analog',		'initodb' => 'isgwanalog_initoDB'),
						array('name' => 'isgw.cas',		'initodb' => 'isgwcas_initoDB'),
						array('name' => 'isgw.gsm',		'initodb' => 'isgwgsm_initoDB'),
						array('name' => 'isgw.causes',		'initodb' => 'isgwcauses_initoDB'),
						array('name' => 'isgw.tones',		'initodb' => null),
						array('name' => 'isgw.cpt',		'initodb' => 'isgwcpt_initoDB'),
						array('name' => 'isgw.dialplan',	'initodb' => 'isgwdialplan_initoDB'),
						array('name' => 'misc.conf',		'initodb' => 'misc_initoDB'),
						array('name' => 'hardware.conf',	'initodb' => 'isdncfg_initoDB'),
						array('name' => 'network.acl',		'initodb' => 'networkacl_initoDB')
					);

		function __construct () {

			preg_match('/[^a-zA-Z0-9=]*?d=(?<serial>.+) /', file_get_contents('/proc/cmdline'), $res);

			$this->_cardSerial = $res['serial'];
			$this->_ba = new beroAri($this->_confPath . '/ari.db');

			if (!is_dir($this->_extractPath)) {
				mkdir($this->_extractPath);
			}
		}

		private function _installUserAppConf () {

			if (!is_dir($this->_confPath . '/userapp')) {
				mkdir($this->_confPath . '/userapp');
				@exec('/bin/chown admin:admin ' . $this->_confPath . '/userapp/');
			}

			$userAppConfDir = scandir($this->_extractPath . '/userapp/');
			foreach ($userAppConfDir as $userAppConfSub) {
				if (($userAppConfSub == '.') || ($userAppConfSub == '..')) {
					continue;
				}

				@exec('/bin/rm -rf ' . $this->_confPath . '/userapp/' . $userAppConfSub);
				@exec('/bin/cp -a ' . $this->_extractPath . '/userapp/' . $userAppConfSub . ' ' . $this->_confPath . '/userapp/' . $userAppConfSub);
				@exec('/bin/chown -R admin:admin ' . $this->_confPath . '/userapp/' . $userAppConfSub);
			}
		}

		function createFullBackup () {

			$archiveName = 'beroNetGW-' . $this->_cardSerial . '-backup.tar.gz';

			foreach ($this->_confFiles as $confFile) {
				if (file_exists($this->_confPath . '/' . $confFile['name'])) {
					$confFiles .= ' ' . $confFile['name'];
				}
			}

			$confFiles .= ' userapp';

			if (file_exists('/tmp/' . $archiveName)) {
				unlink('/tmp/' . $archiveName);
			}

			exec('/bin/tar -czf /tmp/' . $archiveName . ' -C ' . $this->_confPath . ' ' . $confFiles);
			$archiveFile = implode('', file('/tmp/' . $archiveName));

			return(array('name' => $archiveName, 'file' => $archiveFile));
		}

		private function _installConfFile ($confFile, $runIniToDB = true) {

			if (!is_dir($this->_confPath . '/backup')) {
				 mkdir($this->_confPath . '/backup');
			}

			@copy($this->_confPath . '/' . $confFile['name'], $this->_confPath . '/backup/' . $confFile['name']);
			@unlink($this->_confPath . '/' . $confFile['name']);

			if (is_file($this->_extractPath . '/' . $confFile['name'])) {
				copy($this->_extractPath . '/' . $confFile['name'], $this->_confPath . '/' . $confFile['name']);
			}

			if ($runIniToDB == true) {
				if ($confFile['initodb'] == null) {
					return(true);
				}

				if (!$confFile['initodb']($this->_ba, $this->_confPath . '/', 1)) {
					copy($this->_confPath . '/backup/' . $confFile['name'], $this->_confPath . '/' . $confFile['name']);
					return(false);
				}
			}

			return(true);
		}

		function installConfFile ($fileName, $tmpFile = null) {

			foreach ($this->_confFiles as $file) {
				if ($file['name'] == $fileName) {
					$confFile = $file;
					break;
				}
			}

			if (!isset($confFile)) {
				return(false);
			}

			if ($tmpFile != null) {
				copy($tmpFile, $this->_extractPath . '/' . $confFile['name']);
			}

			return($this->_installConfFile($confFile));
		}

		function installFullBackup ($archiveName, $tmpFile) {

			copy($tmpFile, '/tmp/' . $archiveName);
			exec('/bin/tar -xzf /tmp/' . addcslashes($archiveName , ' ()') .' -C ' . $this->_extractPath);

			foreach ($this->_confFiles as $confFile) {
				$this->_installConfFile($confFile, false);
			}

			$this->_installUserAppConf();

			if (!ini_to_db(1)) {
				foreach ($this->_confFiles as $confFile) {
					copy($this->_confPath . '/backup/' . $confFile, $this->_confPath . '/' . $confFile);
				}
				return(false);
			}

			return(true);
		}

		function installCleanup() {
			exec('/bin/rm -rf ' . $this->_extractPath);
		}

		function verifyFileName ($fileName) {

			$ext = explode('.', $fileName, 2);
			if (($ext[1] == 'tar.gz') || ($ext[1] == 'tgz')) {
				return((strcmp($fileName, 'beroNetGW-' . $this->_cardSerial . '-backup.tar.gz') == 0) ? 3 : 2);
			}
			unset($ext);

			$valid = false;
			foreach ($this->_confFiles as $confFile) {
				if ($fileName == $confFile['name']) {
					$valid = true;
					break;
				}
			}

			return(($valid == true) ? 1 : 0);
		}
	}
}
?>
